package com.wissamfawaz;

import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.nio.channels.AsynchronousFileChannel;
import java.nio.channels.CompletionHandler;
import java.nio.charset.Charset;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.concurrent.Future;

public class AsyncFCDemo {

	public static void main(String[] args) throws Exception{
		Path path = Paths.get("in.txt");
		ByteBuffer buffer = ByteBuffer.allocate(124);
		
		AsynchronousFileChannel afc = AsynchronousFileChannel.open(path);
		/*
		 * Future<Integer> operation = afc.read(buffer, 0); while(!operation.isDone());
		 */
		
		afc.read(buffer, 0, buffer, new CompletionHandler<Integer, ByteBuffer>() {

			@Override
			public void completed(Integer result, ByteBuffer attachment) {
				System.out.println("Nb of bytes written to the buffer = " + result);
				buffer.flip();
				CharBuffer charBuffer = Charset.forName("UTF-8").decode(buffer);
				System.out.println(new String(charBuffer.array()));
				
			}

			@Override
			public void failed(Throwable exc, ByteBuffer attachment) {
				System.err.println("Error reading from file.");
				exc.printStackTrace();
			}
		});
		
		Thread.sleep(1);
		System.out.println("Done!");
		

	}

}
