package com.wissamfawaz;

import static java.nio.file.StandardOpenOption.CREATE;
import static java.nio.file.StandardOpenOption.WRITE;

import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.nio.channels.FileChannel;
import java.nio.charset.Charset;
import java.nio.file.Path;
import java.nio.file.Paths;
public class FileChannelDemo {

	public static void main(String[] args) throws Exception {
		Path srcPath = Paths.get("in.txt");
		Path trgtPath = Paths.get("out.txt");
		
		FileChannel srcChannel = FileChannel.open(srcPath);
		FileChannel trgtChannel = FileChannel.open(trgtPath, WRITE, CREATE);
		
		/*
		 * ByteBuffer buffer = ByteBuffer.allocate(1024); int nbOfBytes =
		 * srcChannel.read(buffer); while(nbOfBytes != -1) { buffer.flip();
		 * trgtChannel.write(buffer); buffer.clear(); nbOfBytes =
		 * srcChannel.read(buffer); }
		 */

		//srcChannel.transferTo(0, srcChannel.size(), trgtChannel);
		//trgtChannel.transferFrom(srcChannel, 0, srcChannel.size());
		
		ByteBuffer buffer1 = ByteBuffer.allocate((int) (srcChannel.size()/2));
		ByteBuffer buffer2 = ByteBuffer.allocate(
				(int) srcChannel.size() - (int) srcChannel.size()/2);
		
		ByteBuffer[] buffers = {buffer1, buffer2};
		
		srcChannel.read(buffers);
		buffer1.flip();
		buffer2.flip();
		
		byte[] arr1 = new byte[buffer1.limit()];
		buffer1.get(arr1);
		System.out.println("Content of buffer1: ");
		System.out.println(new String(arr1));
		
		System.out.println("Content of buffer2: ");
		CharBuffer charBuffer = Charset.forName("UTF-8").decode(buffer2);
		System.out.println(new String(charBuffer.array()));
		
		srcChannel.close();
		trgtChannel.close();
	}

}
